﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Atnd
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("Atnd C# Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("atnd -a2 -p567 file        # 2 lines after line-567 ");
                Console.Error.WriteLine("atnd -b3 -p567 file        # 3 lines before line-567 ");
                Console.Error.WriteLine("atnd -c4 -p567 file        # 4 lines before line-567 and 4 lines after line-567");
                Console.Error.WriteLine("atnd -c4 -p567 -n file     # A number appears at the beginning of each line. ");
                Console.Error.WriteLine("atnd -h8 file              # Line-1, Line-2, Line-3, ..., Line-8 ");
                Console.Error.WriteLine("atnd -h8 < file            # Line-1, Line-2, Line-3, ..., Line-8 ");
                Console.Error.WriteLine("atnd -i90-123 file         # Line-90, Line-91, Line-92, ..., Line-123 ");
                Console.Error.WriteLine("atnd -LF -p567 file        # Count lines. Record the max span from LF to LF. ");
                Console.Error.WriteLine("atnd -LF -s\\x2C -p567 file # Record the max span from separator to separator. ");
                Console.Error.WriteLine("atnd -LF -s, -p567 file    # Record the max span from separator to separator. ");
                Console.Error.WriteLine("atnd -LF -s, -f file       # Check if all lines share the field count. ");
                Console.Error.WriteLine("atnd -p567 file            # line-567 ");
                Console.Error.WriteLine("atnd -p567 -8 file         # UTF-8 ");
                Console.Error.WriteLine("atnd -p567 -e file         # EUC-JP ");
                Console.Error.WriteLine("atnd -t9 file              # 9 lines before EOF ");
                Console.Error.WriteLine("atnd -V                    # version ");
                Console.Error.WriteLine("atnd -VC                   # version with comments ");
                Console.Error.WriteLine("DIR | atnd -LF -=DIR -p9   # Display a label (DIR) instead of files. ");
            }
            else
            {
                Console.Error.WriteLine("atnd -a2 -p567 file        ");
                Console.Error.WriteLine("atnd -b3 -p567 file        ");
                Console.Error.WriteLine("atnd -c4 -p567 file        ");
                Console.Error.WriteLine("atnd -c4 -p567 -n file     ");
                Console.Error.WriteLine("atnd -h8 file              ");
                Console.Error.WriteLine("atnd -h8 < file            ");
                Console.Error.WriteLine("atnd -i90-123 file         ");
                Console.Error.WriteLine("atnd -LF -p567 file        ");
                Console.Error.WriteLine("atnd -LF -s\\x2C -p567 file ");
                Console.Error.WriteLine("atnd -LF -s, -p567 file    ");
                Console.Error.WriteLine("atnd -LF -s, -f file       ");
                Console.Error.WriteLine("atnd -p567 file            ");
                Console.Error.WriteLine("atnd -p567 -8 file         ");
                Console.Error.WriteLine("atnd -p567 -e file         ");
                Console.Error.WriteLine("atnd -t9 file              ");
                Console.Error.WriteLine("atnd -V                    ");
                Console.Error.WriteLine("atnd -VC                   ");
                Console.Error.WriteLine("DIR | atnd -LF -=DIR -p9   ");
            }

            return ERROR_CODE;
        }

    }
}
