﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Diyo
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("Diyo C# Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("diyo -f bars.txt     # Edit according to bars.txt ");
                Console.Error.WriteLine("diyo -kﾅ -aN         # ﾅ is subsituted with N. "); // Shift_JIS
                Console.Error.WriteLine("diyo -kﾅ -aN file    # ﾅ is subsituted with N to produce a binary file. ");
                Console.Error.WriteLine("diyo -s① -e１       # ① is subsituted with １ and represented in EUC-JP. ");
                Console.Error.WriteLine("diyo -s① -e１ file  # ① is subsituted with １ to produce a binary file. ");
                Console.Error.WriteLine("diyo -s① -e１ -d    # Do not search a table. ");
                Console.Error.WriteLine("diyo -s① -e１ -q    # Acquire a table name from setting.txt ");
                Console.Error.WriteLine("diyo -s① -e１ -w    # -w shows which table Diyo uses. ");
                Console.Error.WriteLine("diyo -V              # version ");
                Console.Error.WriteLine("diyo -VC             # version with comments ");
            }
            else
            {
                Console.Error.WriteLine("diyo -f bars.txt     ");
                Console.Error.WriteLine("diyo -kﾅ -aN         ");
                Console.Error.WriteLine("diyo -kﾅ -aN file    ");
                Console.Error.WriteLine("diyo -s① -e１       ");
                Console.Error.WriteLine("diyo -s① -e１ file  ");
                Console.Error.WriteLine("diyo -s① -e１ -d    ");
                Console.Error.WriteLine("diyo -s① -e１ -q    ");
                Console.Error.WriteLine("diyo -s① -e１ -w    ");
                Console.Error.WriteLine("diyo -V              ");
                Console.Error.WriteLine("diyo -VC             ");
            }

            return ERROR_CODE;
        }

    }
}
