﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Hetn
{
    public class UpperCaseBlock : IComparable<UpperCaseBlock>
    {
        const string EMPTY = "";

        bool add_ID;
        CheckID c;
        string details, anonymous, summary, unique_ID;

        private void anonymousSummary()
        {
            summary = anonymous;
        }

        private void uniqueSummary()
        {
            string unique_summary = anonymous + unique_ID;
            summary = unique_summary;
        }

        public UpperCaseBlock(string d, string s)
        {
            details = d;
            summary = s.ToUpper();

            add_ID = false;
            anonymous = summary;
            unique_ID = EMPTY;
        }

        public UpperCaseBlock(CheckID check_ID, string d, string s, string u)
        {
            c = check_ID;
            details = d;
            summary = s.ToUpper();
            unique_ID = u;

            add_ID = true;
            anonymous = summary;
        }

        public int CompareTo(UpperCaseBlock b)
        {
            int k = string.Compare(this.summary, b.summary);

            if (k == 0)
            {
                if (add_ID)
                {
                    if (this.unique_ID == b.unique_ID)
                    {
                        ; // k = 0;
                    }
                    else
                    {
                        c.check(unique_ID);

                        this.uniqueSummary();
                        b.uniqueSummary();
                        k = string.Compare(this.summary, b.summary);

                        this.anonymousSummary();
                        b.anonymousSummary();
                    }

                }

            }

            return k;
        }

        public override string ToString()
        {
            return details;
        }

    }
}
