﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Narfi
{
    class Dividing
    {
// Please find "// constructors" for their definitions.
        const char CLEAR = '0';
        const char COMMA = ',';
        const char QUOTE = '"';
        const char SET = '1';
        const int FIELD_COUNT = 3072;
        const int NOT_RECOGNIZED = -1;
        const string EMPTY = "";
        const string N_0TO9 = "0123456789";
        const string N_0TO9_MINUS = "-0123456789";

        bool[] full_house = {true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
            true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true};

        bool[] selected;
        bool remove_separators;
        char separator;
        protected delegate string EditFunction(string s);
        FieldsList f;
        List<string> a; // vector
        protected int field_count;
        string pattern;

        private int leadingNumbers(string full)
        {
            int fullLength = full.Length;
            int k, q;
            string c;
            for (k = 0; k < fullLength; ++k)
            {
                c = full.Substring(k, 1);
                q = N_0TO9.IndexOf(c);
                if (q >= 0)
                {
                    continue;
                }
                else
                {
                    break;
                }

            }

            return k;
        }

        private int positiveOrNegativeNumbers(string full)
        {
            int fullLength = full.Length;
            int q;
            int k = 0;
            string c = full.Substring(k, 1);

            q = N_0TO9_MINUS.IndexOf(c);
            if (q >= 0)
            {
                for (k = 1; k < fullLength; ++k)
                {
                    c = full.Substring(k, 1);

                    q = N_0TO9.IndexOf(c);
                    if (q >= 0)
                    {
                        continue;
                    }
                    else
                    {
                        break;
                    }

                }

            }

            return k;
        }

        private int reachNumber(string full)
        {
            int fullLength = full.Length;
            int k, q;
            string c;
            for (k = 0; k < fullLength; ++k)
            {
                c = full.Substring(k, 1);
                q = N_0TO9_MINUS.IndexOf(c);
                if (q >= 0)
                {
                    break;
                }
                else
                {
                    continue;
                }

            }

            return k;
        }

        private int trailingNumbers(string full)
        {
            int fullLength = full.Length;
            int k, q, n;
            string c;
            for (n = 0; n < fullLength; ++n)
            {
                k = fullLength - 1 - n;
                c = full.Substring(k, 1);

                q = N_0TO9.IndexOf(c);
                if (q >= 0)
                {
                    continue;
                }
                else
                {
                    q = N_0TO9_MINUS.IndexOf(c);
                    if (q >= 0)
                    {
                        ++n;
                    }

                    break;
                }

            }

            return n;
        }

        private void vector_to_array_arranging_in_reverse_order() {
            int k = a.Count - 1;

            foreach(string s in a) {
                f.fieldsList(s, k--);
            }

        }

        private void vector_to_array_complementing(string extra, char bond)
        {
            int k = 0;
            StringBuilder os;

            foreach (string s in a)
            {
                os = new StringBuilder();
                os.Append(s);
                os.Append(bond);
                os.Append(extra);
                f.fieldsList( os.ToString(), k++);
            }

        }

        protected void vector_to_array_editing(EditFunction editing, int field_number)
        {
            int field_number_1 = field_number - 1;
            int k = 0;

            foreach (string s in a)
            {
                if (k == field_number_1)
                {
                    f.fieldsList( editing(s), k++);
                }
                else
                {
                    f.fieldsList(s, k++);
                }

            }

        }

        private void vector_to_array_mapping()
        {
            int k = 0;

            foreach (string s in a)
            {
                f.fieldsList(s, k++);
            }

        }

        public int complementing_fields_list(string p, string extra, char bond)
        {
            smashed_to_pieces(p);

            vector_to_array_complementing(extra, bond);
            return field_count;
        }

        public virtual int editing(string p, int field_number)
        {
            smashed_to_pieces(p);

            vector_to_array_editing(transparent, field_number);
            return field_count;
        }

        public int extracting_decimal_from_field(string p, int field_number)
        {
            smashed_to_pieces(p);

            vector_to_array_editing(extract_decimal, field_number);
            return field_count;
        }

        public int extracting_integer_from_field(string p, int field_number)
        {
            smashed_to_pieces(p);

            vector_to_array_editing(extract_integer, field_number);
            return field_count;
        }

        public int mapping_fields_list(string p)
        {
            smashed_to_pieces(p);

            vector_to_array_mapping();
            return field_count;
        }

        public int reversing_fields_list(string p)
        {
            smashed_to_pieces(p);

            vector_to_array_arranging_in_reverse_order();
            return field_count;
        }

        public int search_separator(string p, int beginning)
        {
            bool no_splitting = false;
            char n;
            int k;
            int s = NOT_RECOGNIZED;

            for (k = beginning; k < p.Length; ++k)
            {
                n = p[k];

                if (no_splitting)
                {
                    if (n == QUOTE)
                    {
                        no_splitting = false;
                    }

                    continue; // Commas disappear if placed in quotes.
                }

// splitting
                if (n == QUOTE)
                {
                    no_splitting = true;
                }
                else if (n == separator)
                {
                    s = k;
                    break;
                }

            }

            return s;
        }

        public int smashed_to_pieces(string p)
        {
            bool no_splitting = false;
            char n;
            int field_number = 1;
            int m = 0;
            StringBuilder os = new StringBuilder();

            for (int k = 0; k < p.Length; ++k)
            {
                n = p[k];

                if (no_splitting)
                {
                    if (n == QUOTE)
                    {
                        no_splitting = false;
                        if (selected[field_number])
                        {
                            os.Append(n);
                            ++m;
                        }

                    }
                    else if (n == separator)
                    {
                        if (remove_separators)
                        {
                            continue;
                        }
                        else
                        {
                            if (selected[field_number])
                            {
                                os.Append(n);
                                ++m;
                            }

                        }

                    }
                    else
                    {
                        if (selected[field_number])
                        {
                            os.Append(n);
                            ++m;
                        }

                    }

                    continue;
                }

// splitting
                if (n == QUOTE)
                {
                    no_splitting = true;
                    if (selected[field_number])
                    {
                        os.Append(n);
                        ++m;
                    }

                }
                else if (n == separator)
                {
                    if (selected[field_number])
                    {
                        a.Add( os.ToString() ); // List<string>
                    }

                    os = new StringBuilder();
                    m = 0;
                    field_number += 1;
                    if (field_number > field_count)
                    {
                        break;
                    }

                }
                else
                {
                    if (selected[field_number])
                    {
                        os.Append(n);
                        ++m;
                    }

                }

            }

            if (m > 0)
            {
                if (selected[field_number])
                {
                    a.Add( os.ToString() ); // List<string>
                }

            }
            else
            {
                field_number -= 1;
            }

            field_count = field_number;
            return m;
        }

        public string reverse_unite(string p)
        {
            smashed_to_pieces(p);

            string[] fields = new string[field_count];
            StringBuilder os = new StringBuilder();

            a.CopyTo(fields, 0);

            for (int k = a.Count - 1; k >= 0; --k)
            {
                os.Append(fields[k]);
                os.Append(separator);
            }

            return os.ToString();
        }

        public string unite(string p)
        {
            smashed_to_pieces(p);

            StringBuilder os = new StringBuilder();

            foreach (string s in a)
            {
                os.Append(s);
                os.Append(separator);
            }

            return os.ToString();
        }

        public string unite(string p, bool listed)
        {
            if (! listed)
            {
                mapping_fields_list(p);
            }

            StringBuilder os = new StringBuilder();

            for (int i = 0; i < field_count; ++i)
            {
                os.Append( f.fieldsList(i) );
                os.Append(separator);
            }

            return os.ToString();
        }

        public void unite(List<string> a, ComboAppend c, string p)
        {
            if (a.Count == 0)
            {
                mapping_fields_list(p);
            }

            for (int k = 0; k < field_count; ++k)
            {
                c.append( f.fieldsList(k) );
                c.append(separator);
            }

//            return c.built();
        }

        public string supplying_bits(int c)
        {
            StringBuilder os = new StringBuilder();

            field_count = c;
            if (field_count > FIELD_COUNT)
            {
                field_count = FIELD_COUNT;
            }

            for (int i = 0; i < field_count; ++i)
            {
                os.Append(SET);
            }

            pattern = os.ToString();
            return pattern;
        }

        public string surge_of_set_bits(int f, int from, int to)
        {
        //   surge_of_set_bits
        // 0011111000000000000, for example
            field_count = f;

            int from_1 = from - 1;
            int k;
            int surge_length = to - from + 1;
            int to_1 = to - 1;
            StringBuilder os = new StringBuilder();

            if (surge_length > field_count)
            {
                surge_length = field_count;
                for (int i = 0; i < surge_length; ++i)
                {
                    os.Append(SET);
                }

            }
            else
            {
                for (k = 0; k < from_1; ++k)
                {
                    os.Append(CLEAR);
                }

                for (k = from_1; k <= to_1; ++k)
                {
                    os.Append(SET);
                }

                for (k = to; k < field_count; ++k)
                {
                    os.Append(CLEAR);
                }

            }

            pattern = os.ToString();
            return pattern;
        }

// constructors
        public Dividing()
        {
            f = new FieldsList();
            separator = COMMA;

            field_count = FIELD_COUNT;
            remove_separators = false;

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                selected[ m + 1 ] = true;
            }

        }

        public Dividing(FieldsList fields_list, char s)
        {
            f = fields_list;
            separator = s;

            field_count = FIELD_COUNT;
            remove_separators = false;

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                selected[ m + 1 ] = true;
            }

        }

        public Dividing(FieldsList fields_list, char s, bool e)
        {
            f = fields_list;
            separator = s;
            remove_separators = e;

            field_count = FIELD_COUNT;

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                selected[ m + 1 ] = true;
            }

        }

        public Dividing(FieldsList fields_list, char s, byte c)
        {
            f = fields_list;
            separator = s;
            field_count = (int)c; // 0 to 255

            remove_separators = false;
            selected = full_house;

            a = new List<string>();
        }

        public Dividing(FieldsList fields_list, char s, byte c, bool e)
        {
            f = fields_list;
            separator = s;
            field_count = (int)c; // 0 to 255
            remove_separators = e;

            selected = full_house;

            a = new List<string>();
        }

        public Dividing(FieldsList fields_list, int c, char s)
        {
            f = fields_list;
            separator = s;

            remove_separators = false;

            field_count = c;
            if (field_count > FIELD_COUNT)
            {
                field_count = FIELD_COUNT;
            }

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                selected[ m + 1 ] = true;
            }

        }

        public Dividing(FieldsList fields_list, int c, char s, bool e)
        {
            f = fields_list;
            separator = s;
            remove_separators = e;

            field_count = c;
            if (field_count > FIELD_COUNT)
            {
                field_count = FIELD_COUNT;
            }

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                selected[ m + 1 ] = true;
            }

        }

        public Dividing(FieldsList fields_list, string p, char s, byte c)
        {
            char r;

            f = fields_list;
            pattern = p;
            separator = s;
            field_count = (int)c; // 0 to 255

            remove_separators = false;

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                r = p[m];
                selected[ m + 1 ] = (r == SET) ? true : false;
            }

        }

        public Dividing(FieldsList fields_list, string p, char s, byte c, bool e)
        {
            char r;

            f = fields_list;
            pattern = p;
            separator = s;
            field_count = (int)c; // 0 to 255
            remove_separators = e;

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                r = p[m];
                selected[ m + 1 ] = (r == SET) ? true : false;
            }

        }

        public Dividing(FieldsList fields_list, string p, int c, char s)
        {
            char r;

            f = fields_list;
            pattern = p;
            separator = s;

            remove_separators = false;

            field_count = c;
            if (field_count > FIELD_COUNT)
            {
                field_count = FIELD_COUNT;
            }

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                r = p[m];
                selected[ m + 1 ] = (r == SET) ? true : false;
            }

        }

        public Dividing(FieldsList fields_list, string p, int c, char s, bool e)
        {
            char r;

            f = fields_list;
            pattern = p;
            separator = s;
            remove_separators = e;

            field_count = c;
            if (field_count > FIELD_COUNT)
            {
                field_count = FIELD_COUNT;
            }

            a = new List<string>();
            selected = new bool[ field_count + 1 ];
            for (int m = 0; m < field_count; ++m)
            {
                r = p[m];
                selected[ m + 1 ] = (r == SET) ? true : false;
            }

        }

        string extract_decimal(string field)
        {
            int digit_count, p, trace;
            string head, tail;
            StringBuilder os = new StringBuilder();

            p = field.IndexOf('.');
            if (p >= 0)
            {
                trace = p;
                head = field.Substring(0, p);
                tail = field.Substring( p + 1 );

                digit_count = leadingNumbers(tail);
                tail = tail.Substring(0, digit_count);

                digit_count = trailingNumbers(head);
                if (digit_count == 0)
                {
                    head = "0";
                }
                else
                {
                    p = trace - digit_count;
                    head = head.Substring(p, digit_count);
                }

                os.Append(head);
                os.Append('.');
                os.Append(tail);
            }
            else
            {
                os.Append('0');
                os.Append('.');
                os.Append('0');
            }

            return os.ToString();
        }

        string extract_integer(string field)
        {
            int digit_count, p;
            string body = EMPTY;
            int not_found = field.Length;

            p = reachNumber(field);
            if (p == not_found)
            {
                body = "0";
            }
            else
            {
                body = field.Substring(p);
                digit_count = positiveOrNegativeNumbers(body);
                body = body.Substring(0, digit_count);
            }

            return body;
        }

        string transparent(string field)
        {
            return field;
        }

    }
}
