﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Obot
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("Obot C# Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("obot -b2048 text      # Read 2048 bytes. ");
                Console.Error.WriteLine("obot -c20 text        # Produce a table that has 20 fields or less. ");
                Console.Error.WriteLine("obot -m3 text         # 3 lines can be represented in hexadecimal as 20 0D 0A..");
                Console.Error.WriteLine("obot -m3 -s\\x2C text  # CSV ");
                Console.Error.WriteLine("obot -m45 -r20 text   # Produce a table that has 20 rows or less. ");
                Console.Error.WriteLine("obot exe              # EXE can be represented in hexadecimal as 4D 5A... ");
                Console.Error.WriteLine("obot -V               # version ");
                Console.Error.WriteLine("obot -VC              # version with comments ");
            }
            else
            {
                Console.Error.WriteLine("obot -b2048 text      ");
                Console.Error.WriteLine("obot -c20 text        ");
                Console.Error.WriteLine("obot -m3 text         ");
                Console.Error.WriteLine("obot -m3 -s\\x2C text  ");
                Console.Error.WriteLine("obot -m45 -r20 text   ");
                Console.Error.WriteLine("obot exe              ");
                Console.Error.WriteLine("obot -V               ");
                Console.Error.WriteLine("obot -VC              ");
            }

            return ERROR_CODE;
        }

    }
}
