﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Rufeol
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("Rufeol C# Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("rufeol -m csv        # Remove a separator from every end of line. ");
                Console.Error.WriteLine("rufeol -u3 text      # Remove 3 unnecessary characters from every end of line. ");
                Console.Error.WriteLine("rufeol -u3 text new  # Read text to produce a new file. ");
                Console.Error.WriteLine("rufeol -u3 -r text   # Every line includes 0Dh. ");
                Console.Error.WriteLine("rufeol -u3 -y text   # Do not remove binary.tmp ");
                Console.Error.WriteLine("rufeol -u3 -w2 text  # Read a double-spaced text to produce a draft. ");
                Console.Error.WriteLine("rufeol -x2 text      # Read a double-spaced text to produce a draft. ");
                Console.Error.WriteLine("rufeol -V            # version ");
                Console.Error.WriteLine("rufeol -VC           # version with comments ");
                Console.Error.WriteLine("rufeol --help        # version with comments ");
            }
            else
            {
                Console.Error.WriteLine("rufeol -m csv        ");
                Console.Error.WriteLine("rufeol -u3 text      ");
                Console.Error.WriteLine("rufeol -u3 text new  ");
                Console.Error.WriteLine("rufeol -u3 -r text   ");
                Console.Error.WriteLine("rufeol -u3 -y text   ");
                Console.Error.WriteLine("rufeol -u3 -w2 text  ");
                Console.Error.WriteLine("rufeol -x2 text      ");
                Console.Error.WriteLine("rufeol -V            ");
                Console.Error.WriteLine("rufeol -VC           ");
                Console.Error.WriteLine("rufeol --help        ");
            }

            return ERROR_CODE;
        }

    }
}
