﻿using System;
using System.Configuration;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Hanzen
{
    class CommandPath
    {
        const int FIELD_COUNT = 3072;
        const string EMPTY = "";

        Exception e;
        string line;

        private bool openClose(string fileName)
        {
            bool b = true;

            try
            {
                Stream testFile = File.OpenRead(fileName);
                testFile.Close();
            }
            catch (IOException e175)
            {
                b = false;
                e = e175;
            }
            catch (Exception e176)
            {
                b = false;
                e = e176;
            }

            return b;
        }

        public CommandPath()
        {
            line = Environment.GetEnvironmentVariable("Path");
        }

        public string info() {
            return e.ToString();
        }

        public string pathName(string extra)
        {
            FieldsList f = new FieldsList();
            Dividing d = new Dividing(f, ';');
            int field_count = d.complementing_fields_list(line, extra, '\\');
            string fullPath = EMPTY;

            for (int i = 0; i < field_count; ++i)
            {
                fullPath = f.fieldsList(i);
                if ( openClose(fullPath) )
                {
                    return fullPath;
                }

            }

            return EMPTY;
        }

    }
}
