﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Narfi
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("Narfi Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("narfi -c4 wide             # Produce narfi.txt that has 4 fields. ");
                Console.Error.WriteLine("narfi -c4 wide narrow      # Produce a narrow file that has 4 fields. ");
                Console.Error.WriteLine("narfi -c4 -L wide narrow   # 0Dh is removed from every line. ");
                Console.Error.WriteLine("narfi -c4 < wide > narrow  # Produce a narrow file that has 4 fields. ");
                Console.Error.WriteLine("narfi -c4 -8 wide          # UTF-8 ");
                Console.Error.WriteLine("narfi -c4 -b1011 wide      # narfi.txt has Field-1, Field-3 and Field-4. ");
                Console.Error.WriteLine("narfi -c4 -d2 wide         # Remove combining characters. ");
                Console.Error.WriteLine("narfi -c4 -d2 -p wide      # H and I are omitted from ASCII characters. ");
                Console.Error.WriteLine("narfi -c4 -e2 wide         # Extract a decimal from Field-2. ");
                Console.Error.WriteLine("narfi -c4 -i2-3 wide       # narfi.txt has Field-2 and Field-3. ");
                Console.Error.WriteLine("narfi -c4 -k2 -a_ wide     # In Field-2, narfi replaces katakana with ascii.");
                Console.Error.WriteLine("narfi -c4 -n2 wide         # Extract an integer from Field-2. ");
                Console.Error.WriteLine("narfi -c4 -o2 wide         # Remove control characters from Field-2. ");
                Console.Error.WriteLine("narfi -c4 -q wide          # Commas disappear if placed in quotes. ");
                Console.Error.WriteLine("narfi -c4 -r wide          # Arrange fields in reverse order. ");
                Console.Error.WriteLine("narfi -c4 -s, wide         # CSV ");
                Console.Error.WriteLine("narfi -c4 -s\\l wide        # Wiki table ");
                Console.Error.WriteLine("narfi -c4 -s\\l -x- csv     # Do not check if the file name includes .csv ");
                Console.Error.WriteLine("narfi -c4 -s\\x7C wide      # Wiki table ");
                Console.Error.WriteLine("narfi -c4 -u wide          # EUC-JP ");
                Console.Error.WriteLine("narfi -c255 -f wide        # Check if all lines share the field count. ");
                Console.Error.WriteLine("narfi -V                   # version ");
                Console.Error.WriteLine("narfi -VC                  # version with comments ");
            }
            else
            {
                Console.Error.WriteLine("narfi -c4 wide             ");
                Console.Error.WriteLine("narfi -c4 wide narrow      ");
                Console.Error.WriteLine("narfi -c4 -L wide narrow   ");
                Console.Error.WriteLine("narfi -c4 < wide > narrow  ");
                Console.Error.WriteLine("narfi -c4 -8 wide          ");
                Console.Error.WriteLine("narfi -c4 -b1011 wide      ");
                Console.Error.WriteLine("narfi -c4 -d2 wide         ");
                Console.Error.WriteLine("narfi -c4 -d2 -p wide      ");
                Console.Error.WriteLine("narfi -c4 -e2 wide         ");
                Console.Error.WriteLine("narfi -c4 -i2-3 wide       ");
                Console.Error.WriteLine("narfi -c4 -k2 -a_ wide     ");
                Console.Error.WriteLine("narfi -c4 -n2 wide         ");
                Console.Error.WriteLine("narfi -c4 -o2 wide         ");
                Console.Error.WriteLine("narfi -c4 -q wide          ");
                Console.Error.WriteLine("narfi -c4 -r wide          ");
                Console.Error.WriteLine("narfi -c4 -s, wide         ");
                Console.Error.WriteLine("narfi -c4 -s\\l wide        ");
                Console.Error.WriteLine("narfi -c4 -s\\l -x- csv     ");
                Console.Error.WriteLine("narfi -c4 -s\\x7C wide      ");
                Console.Error.WriteLine("narfi -c4 -u wide          ");
                Console.Error.WriteLine("narfi -c255 -f wide        ");
                Console.Error.WriteLine("narfi -V                   ");
                Console.Error.WriteLine("narfi -VC                  ");
            }

            return ERROR_CODE;
        }

    }
}
