﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SjisEuc
{
    class Guide
    {
        const int ERROR_CODE = 1;
        const string EMPTY = "";

        public int versionGuide(double versionNumber, bool comments)
        {
            Console.Error.Write("SjisEuc C# Version ");
            Console.Error.WriteLine(versionNumber);
            Console.Error.WriteLine(EMPTY);

            if (comments)
            {
                Console.Error.WriteLine("sjiseuc SJIS            # Produce sjiseuc.txt ");
                Console.Error.WriteLine("sjiseuc SJIS EUC        # Produce a new file. ");
                Console.Error.WriteLine("sjiseuc < SJIS > EUC    # Every line includes 0Dh. ");
                Console.Error.WriteLine("sjiseuc -a SJIS         # Acquire a table name from sete.txt ");
                Console.Error.WriteLine("sjiseuc -b SJIS         # Produce binary.tmp ");
                Console.Error.WriteLine("sjiseuc -b SJIS SJIS    # Produce and rename binary.tmp ");
                Console.Error.WriteLine("sjiseuc -b -y SJIS      # Do not remove binary.tmp ");
                Console.Error.WriteLine("sjiseuc -d SJIS         # Do not search a table. ");
                Console.Error.WriteLine("sjiseuc -L SJIS         # 0Dh is removed from every line. ");
                Console.Error.WriteLine("sjiseuc -L- SJIS        # Every line includes 0Dh. ");
                Console.Error.WriteLine("sjiseuc -s SJIS         # Skip control characters except 0Ah. ");
                Console.Error.WriteLine("sjiseuc -t SJIS EUC     # SJIS has the same time as EUC. ");
                Console.Error.WriteLine("sjiseuc -w SJIS         # -w shows which table sjiseuc uses.");
                Console.Error.WriteLine("sjiseuc -V              # version ");
                Console.Error.WriteLine("sjiseuc -VC             # version with comments ");
            }
            else
            {
                Console.Error.WriteLine("sjiseuc SJIS            ");
                Console.Error.WriteLine("sjiseuc SJIS EUC        ");
                Console.Error.WriteLine("sjiseuc < SJIS > EUC    ");
                Console.Error.WriteLine("sjiseuc -a SJIS         ");
                Console.Error.WriteLine("sjiseuc -b SJIS         ");
                Console.Error.WriteLine("sjiseuc -b SJIS SJIS    ");
                Console.Error.WriteLine("sjiseuc -b -y SJIS      ");
                Console.Error.WriteLine("sjiseuc -d SJIS         ");
                Console.Error.WriteLine("sjiseuc -L SJIS         ");
                Console.Error.WriteLine("sjiseuc -L- SJIS        ");
                Console.Error.WriteLine("sjiseuc -s SJIS         ");
                Console.Error.WriteLine("sjiseuc -t SJIS EUC     ");
                Console.Error.WriteLine("sjiseuc -w SJIS         ");
                Console.Error.WriteLine("sjiseuc -V              ");
                Console.Error.WriteLine("sjiseuc -VC             ");
            }

            return ERROR_CODE;
        }

    }
}
