﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace SjisEuc
{
    class OpenClose
    {
        string readable_file, new_name, suggested_name;

        public OpenClose(string s)
        {
            suggested_name = s;
        }

        public bool openClose(string file_name, bool write)
        {
            bool b = true;
            Encoding MS932 = Encoding.GetEncoding(932);

            if (write)
            {
                try
                {
                    File.Delete(file_name);
                    Stream testFile = File.OpenWrite(file_name);
                    new_name = file_name;
                    testFile.Close();
                }
                catch (IOException e79)
                {
                    Error.handler( e79.ToString() );
                    b = false;
                    new_name = suggested_name;
                }
                catch (Exception e80)
                {
                    Error.handler( e80.ToString() );
                    b = false;
                    new_name = suggested_name;
                }

            }
            else
            {
                try
                {
                    StreamReader testFile = new StreamReader(file_name, MS932);
                    readable_file = file_name;
                    testFile.Close();
                }
                catch (IOException e81)
                {
                    Error.handler( e81.ToString() );
                    b = false;
                    throw new Exception( "StreamReader() error:" + file_name );
                }
                catch (Exception e82)
                {
                    Error.handler( e82.ToString() );
                    b = false;
                    throw new Exception( "StreamReader() error:" + file_name );
                }

            }

            return b;
        }

        public string readable()
        {
            return readable_file;
        }

        public string newName()
        {
            return new_name;
        }

    }
}
